/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 754 $ $LastChangedDate: 2002-08-31 15:50:08 +0200 (Sat, 31 Aug 2002) $
 *
 * Bind - Name binder. 
 */
 
open Ast;

/* Bind symbols, i.e. replace Simple_name and Qualified_name in <'a>bindable
 * with Symbol. This is two phase process, first all symbols are entered
 * into global namespace, and then symbols are bound. 
 *
 * Second phase also ensures all named types have right number of type
 * parameters.
 */

// This has to be called first, once per compiled module.
void init_binder(id mod_name, bool iface);
void finish_bind();

void enter_decl(decl d); 
void bind_decl(decl d); 

// Save compiled module interface to given filename.
void save_module(string filename);

<id>list used_modules();
<id>list referenced_modules();
<id>list used_exns();
