/**
+ Bolek memorized

This will be our next-to-last meeting with Bolek, we'll teach it to remember
last value computed so we can recall it (by supplying "x" or "X" instead
of number). We'll also make it print somewhat more user-friendly error
messages.
*/

int last_expr = 0;	// {0}

void process_line()
{
	// flag set to true if there were problems reading input
	bool problems = false;
	
	// {1}
	int read_x_or_int()
	{
		string v = read_string();

		// {2}
		if (v == "x" || v == "X")
			return last_expr;
		else {
			// {3}
			try {
				// {4}
				return atoi(v);
			} with {
			// {5}
			case Invalid_argument(_):
				puts("bad number:  " + v +"\n");
				// {6}
				problems = true;
				return 0;
			}
		}
	}

	puts("bolek ]I[ > ");

	int x, y, res;
	string op;
	
	(x, op, y) = (read_x_or_int(), read_string(), read_x_or_int());

	switch op {
	case "+": 	res = x + y;
	case "-": 	res = x - y;
	case ":":
	case "/": 	res = x / y;
	case "*": 	res = x * y;
	case _:		// {7}
		puts("Invalid operator: " + op + "\n");
		return;
	}
	
	if (!problems)
		puts("result: " + itoa(res) + "\n");
	last_expr = res;
}

section init
{
	for (int line = 1; line < 5; line++) {	// {8}
		puts("[line: " + itoa(line) + "] ");
		process_line();
	}
}

/**
{0} Global variables are defined much like in C.  Global variables are 
initialized either in place of their definition or in "init" sections.  
Right before a call to any function that uses global variables,
or end of last "init" section if there are no such calls, 
all global variables need to be initialized.

{1} Here we have defintion of nested function.  Nested functions are 
visible only in function defining them (i.e. call to [read_x_or_int()]
from init section would be an error).  They can use variables of parent
function.  In this example we set [problems] flag in {6}, which is defined
in parent function.  We'll learn about real power of nested functions
soon.

{2} [==] can work on strings, [||] (and [&&] for that matter) operator 
works just like in C, including lazy sementics. (i.e. in [true && f()]
[f()] is never called).

{3} You can try enter "ble" instead of number into Bolek v2.  You
will see beautifull error message: Gont runtime fatal error: unhandled 
exception, and program will exit.  This is because [read_int()] refused
to convert "ble" to integer, after reading it.  In such circumstances
there was no way [read_int()] could return some useful value, indeed
what is integer value of "ble"? :-)  Therefore [read_int()] raises
"exception".  

Raising exception jumps out to nearest enclosing [try ... with] block.
There exception is matched against exception patterns listed in this
particular block.  If there is no match, exception is raised again.

Now about the exception matching.  It is just a special case of more
general concept called pattern matching.  [atoi()] raises 
[Invalid_argument] exception when it is given argument that is... err,
invalid.  So does [read_int()].  In fact [Invalid_argument] exception
has a string argument, which is by convention name of function that raises
it.  So actual exception raised by [atoi()] is 
[Invalid_argument("Core::atoi")], as the true name of atoi is
Core::atoi.  However the string is there mainly for information,
it's comes in handy when you catch exception far away from place
where it was generated, and would like to know which function generated it.

{5} Here we match exception that might occur during execution
of block enclosed in [{}].  We accept all exceptions of kind
[Invalid_argument].  Just like in {7}, [_] is used to as a match-all 
pattern.  In this context it matches any string being parameter of
[Invalid_argument] exception.

We could as well use [case Invalid_argument("Core::atoi"):] in
this example, to match only exceptions generated by Core::atoi.
However there are few drawbacks of doing so -- for example
if we wanted to catch exceptions from [read_int()] using 
[case Invalid_argument("Core::read_int"):] we would loose, as it raises
[Invalid_argument("Core::atoi")], because it uses [atoi()].  Therfore The
Only Right Thing is [Invalid_argument(_)].

{8} One easy thing for the end.  One can declare variables part of
[for] before first semicolon.  Just like in C++ or C99.  Ah, for no good
reason we limit our great calculator to 5 lines of input ;)
*/
