/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 975 $ $LastChangedDate: 2002-09-14 18:56:32 +0200 (Sat, 14 Sep 2002) $
 *
 * Gontlex - lexer for gont (but not only).
 */

type <'a, 'b>t;
type <'a, 'b>mode;

union <'a, 'b>token {
    string String;
    char Char;
    string Int;
    string Float;
    string Id;
    string Ty_var;
    string Comment;
    string Blank;
    'a Keyword;
    'b Operator;
    void Eof;
}

<'a, 'b>t of_genlex(<'a, 'b>mode, Genlex::t);

*(int, int) beg_location(<'a, 'b>t);
*(int, int) end_location(<'a, 'b>t);
<'a, 'b>token get_token(<'a, 'b>t);

<'a, 'b>mode make_mode();
void add_keyword(<'a, 'b>mode, string, 'a);
void add_operator(<'a, 'b>mode, string, 'b);

void keep_comments(<'a, 'b>mode);
void keep_blanks(<'a, 'b>mode);
void handle_tyvars(<'a, 'b>mode);

exception string Error;

// vim:sts=4:sw=4
