/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 1049 $ $LastChangedDate: 2002-10-27 15:32:45 +0100 (Sun, 27 Oct 2002) $
 */

type pid_t = int;

union wait_status {
	*(int, pid_t) W_exited;
	*(int, pid_t) W_signaled;
	*(int, pid_t) W_signaled_core_dumped;
	*(int, pid_t) W_stopped;
	void W_no_children;
}

union wait_flag {
	void Wf_no_hang;
	void Wf_untraced;
}

wait_status waitpid(pid_t pid, <wait_flag>list flags);

pid_t fork() = "Ipc__fork";
pid_t getpid() = "Ipc__getpid";
pid_t getppid() = "Ipc__getppid";

int execve(string filename, <string>list argv, <string>list env);
int execv(string filename, <string>list argv);

*(int, int) pipe() = "Ipc__pipe";
void dup2(int, int) = "Ipc__dup2";
int dup(int) = "Ipc__dup";
