// $Rev: 975 $ $LastChangedDate: 2002-09-14 18:56:32 +0200 (Sat, 14 Sep 2002) $

section init 
{
	_ s =
"// com1\n"
"# com2\n"
"id1 :::+:: :::+: \"foo\\nbar\" \"fo\\x{6f}\" /*ble/*ble*/ble*/ foo";

	_ m = Gontlex::make_mode();
	Gontlex::handle_tyvars(m);
	Gontlex::keep_comments(m);
	Gontlex::keep_blanks(m);

	List::iter(fun (o) (Gontlex::add_operator(m, o, o)),
		   [":::+::", "::", ":", "+"]);

	_ l = Gontlex::of_genlex(m, Genlex::of_string(s));
	try {
		for (;;) {
			switch Gontlex::get_token(l) {
			case Gontlex::String(s):
				puts("str(" + s + ")\n");
			case Gontlex::Char(c):
				puts("ch(" + itoa(int_of_char(c)) + ")\n");
			case Gontlex::Int(s):
				puts("int(" + s + ")\n");
			case Gontlex::Float(s):
				puts("float(" + s + ")\n");
			case Gontlex::Id(s):
				puts("id(" + s + ")\n");
			case Gontlex::Ty_var(s):
				puts("tv(" + s + ")\n");
			case Gontlex::Comment(s):
				puts("comment(" + s + ")\n");
			case Gontlex::Blank(s):
				puts("blank(" + s + ")\n");
			case Gontlex::Keyword(x):
				puts("keyword(" + x + ")\n");
			case Gontlex::Operator(x):
				puts("op(" + x + ")\n");
			case Gontlex::Eof:
				puts("EOF\n");
				break;
			}
		}
	} with {
	case Gontlex::Error(m):
		puts("gontlex error: " + m + "\n");
	}
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: comment(// com1
 * expected-output: )
 * expected-output: comment(# com2
 * expected-output: )
 * expected-output: id(id1)
 * expected-output: blank( )
 * expected-output: op(:::+::)
 * expected-output: blank( )
 * expected-output: op(::)
 * expected-output: op(:)
 * expected-output: op(+)
 * expected-output: op(:)
 * expected-output: blank( )
 * expected-output: str(foo
 * expected-output: bar)
 * expected-output: blank( )
 * expected-output: str(foo)
 * expected-output: blank( )
 * expected-output: comment(/*ble/*ble*/ble*/)
 * expected-output: blank( )
 * expected-output: id(foo)
 * expected-output: EOF
 */
